package cn.ibizlab.businesscentral.core.odoo_ir.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_ir.domain.Ir_property;
import cn.ibizlab.businesscentral.core.odoo_ir.filter.Ir_propertySearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Ir_property] 服务对象接口
 */
public interface IIr_propertyService extends IService<Ir_property>{

    boolean create(Ir_property et) ;
    void createBatch(List<Ir_property> list) ;
    boolean update(Ir_property et) ;
    void updateBatch(List<Ir_property> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Ir_property get(Long key) ;
    Ir_property getDraft(Ir_property et) ;
    boolean checkKey(Ir_property et) ;
    boolean save(Ir_property et) ;
    void saveBatch(List<Ir_property> list) ;
    Page<Ir_property> searchDefault(Ir_propertySearchContext context) ;
    List<Ir_property> selectByFieldsId(Long id);
    void removeByFieldsId(Long id);
    List<Ir_property> selectByCompanyId(Long id);
    void removeByCompanyId(Long id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


